Imports Microsoft.Office.Interop.Outlook


Public Class wiiFinder

    ' URL to the wii ordering page at BestBuy.com
    Private URL_BestBuy As String = "http://www.bestbuy.com/site/olspage.jsp?skuId=8008559&st=wii+console&type=product&id=1156203165702"

    ' Delegate to use for safe-threading
    Private Delegate Sub ReturnDel(ByVal Store As String, ByVal result As Boolean)

    ' String to hold the store name
    Private BestBuy As String = "BestBuy"



#Region "Events"

    ''' <summary>
    ''' This is just the button on the form that opens the website
    ''' </summary>    
    Private Sub btnBestBuy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBestBuy.Click
        System.Diagnostics.Process.Start(URL_BestBuy)               'Launch the website
    End Sub

#End Region

    ''' <summary>
    ''' Creates a new thread and has it check the best buy website
    ''' </summary>    
    Private Sub Check_BestBuy()
        Dim t As System.Threading.Thread
        t = New System.Threading.Thread(AddressOf Me.Best_Buy_SoldOut)
        t.Start()
    End Sub

    ''' <summary>
    ''' This sub decides if the wii is sold out or not.  It downloads the website into a string
    ''' and searches for the sold out text.
    ''' </summary>    
    Private Sub Best_Buy_SoldOut()
        Dim myWeb As System.Net.WebClient = New System.Net.WebClient
        Dim data As String = myWeb.DownloadString(URL_BestBuy)

        If data.Contains("<b>Shipping:</b> Sold Out") Then
            ReturnVal(BestBuy, False)   'No wii
        Else
            ReturnVal(BestBuy, True)    'HAS WII!!!
        End If
    End Sub


    ''' <summary>
    ''' Handles the result from the Best_Buy_SoldOut() sub
    ''' </summary>
    Private Sub ReturnVal(ByVal Store As String, ByVal result As Boolean)
        'Prevent cross-thread operations
        If Me.lblBestBuy.InvokeRequired Then
            Me.lblBestBuy.Invoke(New ReturnDel(AddressOf ReturnVal), New Object() {Store, result})
            Exit Sub
        End If

        'The store will always = BestBuy; originally I planned on having many stores
        If Store = BestBuy Then
            'Display the time of the last result on the form
            Me.lblLast.Text = System.DateTime.Now.ToString

            'Look at the result
            If result = False Then
                Me.lblBestBuy.Text = "SOLD OUT"
                Me.lblBestBuy.ForeColor = Color.Red
            Else
                Me.lblBestBuy.Text = "IN STOCK"
                Me.lblBestBuy.ForeColor = Color.Green

                'Use Outlook to send an e-mail
                Dim OLApp As New Microsoft.Office.Interop.Outlook.Application
                Dim msg As Microsoft.Office.Interop.Outlook.MailItem

                'Create a new Mail item
                msg = OLApp.CreateItem(Microsoft.Office.Interop.Outlook.OlItemType.olMailItem)

                'Adding recipeints
                msg.Recipients.Add("rob.paulson@gmail.com")
                msg.Recipients.Add("8475300404@messaging.sprintpcs.com ")

                'Add Subject / body
                msg.Subject = "WII!"
                msg.Body = "WII AT BESTBUY.COM!!!!"

                'Send message
                msg.Send()

            End If
        End If

    End Sub


    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Check_BestBuy()
    End Sub




End Class
